# Generated by Django 2.2.3 on 2019-07-23 00:27

import django.contrib.postgres.fields.jsonb
import django.contrib.postgres.indexes
import django.contrib.postgres.search
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import flax_id.django.fields
import olki.apps.corpus.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('federation', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Corpus',
            fields=[
                ('created_at', models.DateTimeField(blank=True, default=django.utils.timezone.now, editable=False)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('id', flax_id.django.fields.FlaxId(editable=False, help_text='A Flax ID that is used as a primary key for the model.', max_length=16, primary_key=True, serialize=False, unique=True)),
                ('title', models.TextField()),
                ('description', models.TextField(blank=True, null=True)),
                ('license', models.TextField(help_text='An [SDPX license](https://spdx.org/licenses/) identifier.')),
                ('language', models.TextField(help_text='An [iso639-1](https://en.wikipedia.org/wiki/ISO_639-1) code.')),
                ('cloned_from', models.URLField(blank=True, help_text='The id or URL of the resource used as a base for this Corpus.', null=True)),
                ('digital_object_identifier', models.URLField(blank=True, help_text='The DOI or DOI URL of the Corpus.', null=True)),
                ('original_publication_at', models.DateTimeField(blank=True, default=None, help_text='Optional original date of publication, if any.', null=True)),
                ('related', django.contrib.postgres.fields.jsonb.JSONField(blank=True, help_text='A list of related URI/identifiers with their DataCite Metadata Scheme as a value.', null=True)),
                ('draft', models.BooleanField(default=True)),
                ('quarantined', models.BooleanField(default=False)),
                ('comments_allowed', models.BooleanField(default=True)),
                ('comments_only_local', models.BooleanField(default=False)),
                ('comments_only_visible_if_approved', models.BooleanField(default=False)),
                ('search_vector', django.contrib.postgres.search.SearchVectorField(null=True)),
                ('actor', models.ForeignKey(help_text='The actor that deposited the corpus.', on_delete=django.db.models.deletion.CASCADE, related_name='corpora_owned', to='federation.Actor')),
            ],
            options={
                'permissions': [('add_corpus_freely', 'Can upload corpus without going through the quarantine system'), ('comment_corpus', 'Can comment corpus'), ('moderate_corpus', 'Can moderate corpus')],
            },
        ),
        migrations.CreateModel(
            name='CorpusAuthor',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(default=None, max_length=200)),
                ('orcid', models.CharField(blank=True, max_length=200, null=True, unique=True)),
            ],
            options={
                'ordering': ['name'],
                'unique_together': {('name', 'orcid')},
            },
        ),
        migrations.CreateModel(
            name='CorpusTag',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(default=None, help_text='WikiData id', max_length=200, unique=True)),
                ('name', models.CharField(default=None, help_text='English name corresponding to the id', max_length=200)),
                ('description', models.CharField(blank=True, help_text='English description corresponding to the id', max_length=500, null=True)),
            ],
            options={
                'ordering': ['name'],
                'unique_together': {('code', 'name', 'description')},
            },
        ),
        migrations.CreateModel(
            name='CorpusFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(blank=True, default=django.utils.timezone.now, editable=False)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('file', models.FileField(upload_to=olki.apps.corpus.models.corpus_directory_path)),
                ('filetype', models.CharField(blank=True, max_length=255, null=True)),
                ('hash', models.CharField(blank=True, max_length=255, null=True)),
                ('name', models.CharField(blank=True, max_length=255, null=True)),
                ('description', models.TextField(blank=True, max_length=2000, null=True)),
                ('corpus', models.ForeignKey(blank=True, help_text='Files of a corpus', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='files', to='corpus.Corpus')),
            ],
            options={
                'ordering': ('name',),
            },
        ),
        migrations.CreateModel(
            name='CorpusAuthorMembership',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('email', models.EmailField(blank=True, max_length=254, null=True)),
                ('affiliation', models.CharField(blank=True, max_length=200, null=True)),
                ('role', models.CharField(blank=True, max_length=200, null=True)),
                ('order', models.IntegerField(help_text='What order to display this person within the corpus.', verbose_name='Order')),
                ('author', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='author_memberships', to='corpus.CorpusAuthor')),
                ('corpus', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='authors_memberships', to='corpus.Corpus')),
            ],
            options={
                'ordering': ['order'],
            },
        ),
        migrations.AddField(
            model_name='corpus',
            name='authors',
            field=models.ManyToManyField(help_text='A list of authors that cannot be given ownership over the corpus (i.e.: because they are remote users).', related_name='corpora_authored', through='corpus.CorpusAuthorMembership', to='corpus.CorpusAuthor'),
        ),
        migrations.AddField(
            model_name='corpus',
            name='tags',
            field=models.ManyToManyField(help_text='A list of tags and categories describing the Corpus.', related_name='corpora_tagged', to='corpus.CorpusTag'),
        ),
        migrations.AddIndex(
            model_name='corpus',
            index=django.contrib.postgres.indexes.GinIndex(fields=['search_vector'], name='corpus_corp_search__b0d76e_gin'),
        ),
    ]
